#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;

require 'config.pl';
require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';
require 'lib/question.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
my $name = user::get_name($uid);

cgilib::header($cgi, "Home");
cgilib::menu($session_id, $name);

print '<center><h3>';
print '<table border=1>';
print '<tr><td align=center>Name</td><td align=center>Score</td></tr>';

my $u;
my $n;
my %score;
my @uid_list = user::list();

foreach $u (@uid_list) {
	$score{$u} = question::total_score($u);
}

foreach $u (sort { $score{$b} <=> $score{$a} } keys(%score)) {
	$n = user::get_name($u);
	print '<tr>';
	print "<td align=center>$n</td>";
	print "<td align=center>$score{$u}</td>";
	print '</tr>';
}

print '</table>';
print '</h3></center>';
cgilib::footer($cgi);
