#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;

require 'config.pl';
require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';
require 'lib/question.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
my $name = user::get_name($uid);

my $qid = $cgi->param('qid');
my $reply = $cgi->param('reply');

my $genre;
my $score;
my $title;
my $question;
my $answer;

($genre, $score, $title, $question, $answer) = question::readfile($qid);

if ($answer ne $reply) {
	cgilib::header($cgi, "Question");
	cgilib::menu($session_id, $name);
	print "<center><h2>";
	print "Bad Answer!";
	print "<br><a href=\"question.cgi?CGISESSID=$session_id\&qid=$qid\">Retry</a>";
	print "</h2></center>";
	cgilib::footer($cgi);
	exit;
}

cgilib::header($cgi, "Question");
cgilib::menu($session_id, $name);
print "<center><h2>";
print "Correct!";
print "</h2></center>";
cgilib::footer($cgi);

question::clear($uid, $qid);
